include(ProcessorCount)

function(calc_unity_batch_size target_name calls_per_core)
ProcessorCount(N)
if(NOT N EQUAL 0)
	get_target_property(source_list ${target_name} SOURCES)
	list(LENGTH source_list source_list_length)
	math(EXPR BATCH_SIZE "${source_list_length}/(${N}*${calls_per_core})")
	if(BATCH_SIZE LESS "8")
		message(DEBUG "calculated BATCH_SIZE=${BATCH_SIZE} set it at least to 8")
		set(BATCH_SIZE "8")
	endif()
	if(BATCH_SIZE GREATER "50")
		message(STATUS "calculated BATCH_SIZE=${BATCH_SIZE} set it max to 50 to limit mem usage")
		set(BATCH_SIZE "50")
	endif()
	
	set_target_properties(${target_name} PROPERTIES UNITY_BUILD_BATCH_SIZE ${BATCH_SIZE})
	message(STATUS "Set UNITY_BUILD_BATCH_SIZE of target ${target_name} to ${BATCH_SIZE}")
endif()

endfunction()